Subject: [PATCH 02/10] gpio: pxa: add explicit includes for cpu_is_X macros

From: [email-masked] (Rob Herring)
Date: Mon, 03 Sep 2012 10:38:50 -0500

On 09/02/2012 10:19 PM, Haojian Zhuang wrote:
> On Fri, Aug 31, 2012 at 6:17 AM, Linus Walleij <[email-masked]> wrote:
>> On Wed, Aug 29, 2012 at 3:31 PM, Rob Herring <[email-masked]> wrote:
>>
>>> From: Rob Herring <[email-masked]>
>>>
>>> In preparation to remove implicit inclusion of mach/gpio.h, add the
>>> necessary includes for cpu_is_X macros.
>>
>> The commit message talks about gpio.h, but...
>>
>>>  #include <mach/irqs.h>
>>> +#include <mach/hardware.h>
>>> +#ifdef CONFIG_ARCH_MMP
>>> +#include <mach/cputype.h>
>>> +#endif
>>
>> This seems completely unrelated, but correct in the sense that every driver
>> should include its resources.
>>
>> But isn't the proper fix to move arch/arm/mach-pxa/include/mach/cputype.h to
>> include/linux/*/pxa-cputype.h or something (note: no clue what "*" should be!),
>> or even better, modify this one driver to take a flag from platform data and/or
>> DT?
>>
>> Anyway, we need the PXA maintainers to look at this.
>>
>> Yours,
>> Linus Walleij
> 
> It's no problem to include cputype.h. I agree Linus's comments to use a same
> name head file. For example, add cputype.h in arch-pxa. Use cputype.h to include
> hardware.h.

I think the right fix is really removing the use of cpu_is_X macros
altogether.

> My question is whether your patches are also based on Arnd's
> multi-header branch.
> I remember that some changes are done in his multiplatform branch. Should we
> do any patches on his multiplatform branch?

It is not based on it. We decided at the ARM mini-summit to not do the
mach header rename and to deprecate including mach headers outside of
arch/arm.

I'm thinking I will just make PXA and MMP select CONFIG_NEED_MACH_GPIO_H
and drop this patch. If pxa and mmp want to be included in
multi-platform images, then this will need to be fixed.

Rob